<?php

/**
 * helpfunctions
 * 
 * @author PKHG 
 * @version $Id$
 * @copyright 2005
 */

//<<<PKHG is camoeflage, voor array ("xxx") $timeserverList zie: http://tf.nist.gov/tf-cgi/servers.cgi;
$timeserverList = array( "time.nist.gov");

$usedTimeserver = 111;

function isLeapYear($tstamp)
{
    $tmp = getdate($tstamp);
    $Year = $tmp['year'];
    return checkdate(2, 29, $Year);
} 

function isPosInt($arg)
{
    if (is_numeric($arg)) {
        return preg_match("/^[0-9]+$/", $arg);
    } else {
        return false ;
    } 
} 

function query_time_server ($timeserver, $socket)
{
    /* Query a time server
   (C) 1999-09-29, Ralf D. Kloth (QRQ.software) <ralf at qrq.de> */

    $fp = fsockopen($timeserver, $socket, $err, $errstr, 15); 
    // parameters: server, socket, error code, error text, timeout
    if ($fp) {
        fputs($fp, "\n");
        $timevalue = fread($fp, 49); 
        // $timevalue2 = fread($fp, 49);
        fclose($fp); # close the connection
    } else {
        $timevalue = 'Ç6yz';
    } 

    $ret = array();
    $ret[] = $timevalue;
    $ret[] = $err; # error code
    $ret[] = $errstr; # error text 
    // $ret['second'] = $timevalue2;
    return($ret);
} # function query_time_server 
function query_time_server_list ($timeserver_list, $socket)
{
    $timefrom = 0;
    $aantalServers = count($timeserver_list);
    for ($i = 0 ; $i < $aantalServers;$i++) {
        $fp = @fsockopen($timeserver_list[$i], $socket, $err, $errstr, 15); 
        // parameters: server, socket, error code, error text, timeout
        if ($fp) {
            fputs($fp, "\n");
            $timevalue = fread($fp, 49);
            fclose($fp); # close the connection
        } else {
            $timevalue = 'Ç6yz' ;
        } 
        $fp = @fsockopen($timeserver_list[$i], $socket, $err, $errstr, 15); 
        // parameters: server, socket, error code, error text, timeout
        if ($fp) {
            fputs($fp, "\n");
            $timevalue2 = fread($fp, 49);
            fclose($fp); # close the connection
        } else {
            $timevalue = 'Ç6yz' ;
        } 

        $usedTimeserver = 100 + $i;
        unset($ret);
        $ret = array();
        $ret[] = $timevalue;
        $ret[] = $err; # error code
        $ret[] = $errstr; # error text      
        $ret[] = 100 + $i;
        $ret['second'] = $timevalue2; 
        // last timeserver reached?
        if ($i == -1 + $aantalServers) {
            return($ret);
        } 
        if (! $fp) {
            continue;
        } 
        return($ret);
    } 
} 

function RadioCheck()
{
    if (!isset($_POST['oost_west'])) {
        // $oost_west = "oostelijk"; default value
        return (1);
    } else {
        if ($_POST['oost_west'] == "oostelijk") {
            return (1);
        } else {
            return(-1);
        } 
    } 
} 

function makeDigit($wat, $type, $stamp)
{
    $tmp = $_POST[$wat];
    if ($tmp == null) {
        $tmp = 0 + date("$type", $stamp - date("Z", $stamp)); 
        // $GMTUur = 0 + $GMTUur;
    } else {
        if (!isset($_POST[$wat])) {
            $tmp = 0 + date("$type", $stamp - date("Z", $stamp));
        } else {
            if (isPosInt($tmp)) {
                $tmp = 0 + $tmp;
            } else {
                $tmp = 0 + date("$type", $stamp - date("Z", $stamp));
            } 
        } 
    } 
    return $tmp;
} 

?>
