<?php

/**
 * Orderoftime
 *
 * @author PKHG
 * @version $Id$
 * @copyright 2005
 */

session_start();
//set language
if ($_GET['lang'] != null) {
    $lang = $_GET['lang'];
    // echo("lang = $lang =<br>");
    if (($lang != 'NL') && ($lang != 'UK') && ($lang != 'DE')) {
        $lang = 'NL';
    }
} else {
    $lang = "NL";
}
$old_info = array();
// prepare 'old' values
if (isset($_SESSION['orderoftime'])) {
    //$old_info = split(" ", $_SESSION['orderoftime']);
    $old_info = preg_split('/ /', $_SESSION['orderoftime']);
    if (count($old_info) < 4) {
        $_SESSION['orderoftime'] = "0 0 oostelijk NL";
    }
} else {
    $_SESSION['orderoftime'] = "0 0 oostelijk NL";
}
//$old_info = split(" ", $_SESSION['orderoftime']);
$old_info = preg_split('/ /', $_SESSION['orderoftime']);
$lengte_POST = count($_POST);
if ($lengte_POST == 0) {
    $_POST['lengtegraad'] = $old_info[0];
	$_POST['lengteminuten'] = $old_info[1];
	$_POST['oost_west'] = $old_info[2];
}

// get help files
include_once("./class.TemplatePower.inc.php");
include_once('./daycorrection.php');
include_once('./helpfunctions.php');

$timercvd = query_time_server_list($timeserverList, 37);
$date = 0;
$tmestamp = 0;
if (!$timercvd[1]) {
    // if no error from query_time_server
    $timevalue = bin2hex ($timercvd[0]);
    $timevalue = abs (HexDec('7fffffff') - HexDec($timevalue) - HexDec('7fffffff')) ;
    $tmestamp = $timevalue - 2208988800; # convert to UNIX epoch time stamp
    $datum = date("Y-m-d (D) H:i:s", $tmestamp - date("Z", $tmestamp));
    $errormessage = '';
} else {
    $errormessage = "<p>Unfortunately, the (bo!) time server $timeserver could not be reached at this time.<br> ";
    $errormessage .= "$timercvd[1] $timercvd[2].<br>\n";
    $errormessage .= "local time used.</>";
    $tmestamp = time();
    $datum = date("Y-m-d (D) H:i:s", $tmestamp - date("Z", $tmestamp));
    // incl time zone offset
    $GMTUur = date("H", $tmestamp - date("Z", $tmestamp));
}
// get all (hidden) data
$lengtegraad = 0 + (int)@$_POST['lengtegraad'];

if (!isPosInt($lengtegraad)) {
    $lengtegraad = $old_info[0];
}
if ($lengtegraad > 360) {
    $lengtegraad = 0;
}

$lengteminuten = 0 + (int)@$_POST['lengteminuten'];
if (! isPosInt($lengteminuten)) {
    $lengteminuten = $old_info[1];
}
if ($lengteminuten > 360) {
    $lengteminuten = 0;
}

if ($_POST['oost_west'] == null) {
    $oost_west = $old_info[2];
} else {
    $oost_west = @$_POST['oost_west'];
}
// save for error recovery
// $_SESSION['orderoftime'] = "$lengtegraad $lengteminuten $oost_west $lang";
// create values of today
$GMTUur = makeDigit('GMTUur', "H", $tmestamp);
$GMTMinuten = makeDigit('GMTMinuten', "i", $tmestamp);
$GMTSeconden = 0 + @date("s", $stamp - date("Z", $stamp));
$Jaar = makeDigit('Jaar', 'Y', $tmestamp);
$Maand = makeDigit('Maand', 'm', $tmestamp);
$Dag = makeDigit('Dag', 'd', $tmestamp);
// set stamp volgens invoer!
$tmestamp = mktime($GMTUur, $GMTMinuten, $GMTSeconden, $Maand, $Dag, $Jaar);
// make corrections
$oost_westFactor = RadioCheck();
$checked_oost = '';
$checked_west = '';
if ($oost_westFactor == 1) {
    $checked_oost = 'checked';
} else {
    $checked_west = 'checked';
}

$extra = ($lengtegraad + $lengteminuten / 60) * 4 * 60 * $oost_westFactor;
$tmestamp += $extra ;
$tmp1 = 0 + strftime("%j", $tmestamp - date("Z", $tmestamp));

if (isLeapYear($tmestamp)) {
    $tijdcorrectie = - $DCschrik[$tmp1];
} else {
    $tijdcorrectie = - $DCnormaal[$tmp1];
}
$tmestamp += $tijdcorrectie ;
$datum = strftime("%A %d %B %Y  %H:%M", $tmestamp) . "  cor.(sec): $tijdcorrectie";
// display file
$file = "zonnetijd_php_$lang.html";

$tpl = new TemplatePower($file);
$tpl->prepare();
$tpl->assign('errormessage', "$errormessage");
$tpl->assign("today", "$datum");
$tpl->assign('lengtegraad', "$lengtegraad");
$tpl->assign('lengteminuten', "$lengteminuten");
$tpl->assign('checked_oost', "$checked_oost");
$tpl->assign('checked_west', "$checked_west");
$tpl->assign('GMTUur', "$GMTUur");
$tpl->assign('GMTMinuten', "$GMTMinuten");
$tpl->assign('Jaar', "$Jaar");
$tpl->assign('Maand', "$Maand");
$tpl->assign('Dag', "$Dag");
$tpl->assign('zonnetijd', "$datum");
$tpl->printToScreen();
$_SESSION['orderoftime'] = "$lengtegraad $lengteminuten $oost_west $lang";

?>
